#!/usr/bin/perl

################################################################################
#     Beomdori's Board v1.2
#
#     Programmer : BeomGyu, Lee
#     E-Mail          : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

require "./config.cgi";
################################################################################
$gLockFlag = "N";
$gLockStat = "N";
 
umask(000);
&parseArgument;

sub parseArgument {
    local($pair,$name,$value,$content_type,$content_length,$buffer,$dump,$boundary,$line,$array_value);
    local(@pairs,@column);

    if($ENV{'QUERY_STRING'}) {
    @pairs = split(/&/,$ENV{'QUERY_STRING'});

        foreach $pair (@pairs) {
            ($name, $value) = split(/=/,$pair);

            $value =~ tr/+/ /;
            $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

            $FORM{$name} = $value;
        } 
    }
    else {
        $content_type = $ENV{'CONTENT_TYPE'};
        $content_length = $ENV{'CONTENT_LENGTH'};

        binmode STDIN;
        read(STDIN,$buffer,$content_length);
 
        if((!$content_type) ||
           ($content_type eq 'application/x-www-form-urlencoded')) {
            @pairs = split(/&/, $buffer);

            foreach $pair (@pairs)  {
                ($name, $value) = split(/=/,$pair);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 
                $FORM{$name} = $value;
            }
        }
        elsif($content_type =~ m#^multipart/form-data#) {
            ($boundary = $content_type) =~ s/^.*boundary=(.*)$/\1/;
            @pairs = split(/--$boundary/, $buffer);
            @pairs = splice(@pairs,1,$#pairs-1);

            for $pair (@pairs)  {
                ($dump,$line,$value) = split(/\r\n/,$pair,3);
                if($line =~ /filename/) {
	            $S_RealFile = $line;
                }

                next if $line =~ /filename=\"\"/;
                $line =~ s/^Content-Disposition: form-data; //;
                (@column) = split(/;\s+/, $line);
                ($name = $column[0]) =~ s/^name="([^"]+)"$/\1/g;
 
                if($#column > 0) { 
                    if($value =~ /^Content-Type:/)  {
                        ($dump,$dump,$value) = split(/\r\n/,$value,3);
                    }
                    else {
                        ($dump,$value) = split(/\r\n/,$value,2);
                    }
                }
                else {
                    ($dump,$value) = split(/\r\n/,$value,2);
                    if(grep(/^$name$/, keys(%CGI))) {
                        if(@{$FORM{$name}} > 0) {
                            push(@{$FORM{$name}}, $value);
                        }
                        else { 
                            $array_value = $FORM{$name};
                            undef $FORM{$name};
                            $FORM{$name}[0] = $array_value;
                            push(@{$FORM{$name}}, $value);
                        }
                    }
                    else {
                        next if $value =~ /^\s*$/;
                        $FORM{$name} = $value;
                        chop($FORM{$name});
	                chop($FORM{$name});
                    }
                    next;
                }
                $FORM{$name} = $value;
            }
        }
        else {
            print "Invalid content type!\n";
            exit(1);
        }
    }
    
    if($FORM{'db'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'db'}";
        $gNumFile = "$FORM{'db'}_num.cgi";
        $gCfgFile = "$FORM{'db'}_cfg.cgi";
        $gPwdFile = "$FORM{'db'}_pwd.cgi";
        $gDatFile = "$FORM{'db'}_dat.cgi";
    }
    else {
        &HTMLHeader;
        print "<center><br><font color=$gTextColor><b>ũϴ </b></font>\n";
        print "<br><br><hr noshade width=400>\n";
        print "<font color=black>$gCGI_Board<font color=red>?db=DB</font></font><br>\n";
        print "<hr noshade width=400><p></center>\n";
        &HTMLFooter;
    }
    
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        &GET_COOKIE;    	        
        if($COOKIE{'ROOTADMIN'} eq $gSupervisor_Password) {
           &selectAction;
        }
        else {
            &HTMLHeader;
            print "<center><br><br><hr noshade width=400><br>\n";
            print "<font color=red><b>ڸ DB   ֽϴ.</b></font><br><br>\n";
            print "<hr noshade width=400><p></center>\n";
            &HTMLFooter;
        }
    }
}

# Խ  - ɿ  ˸  ̵
sub selectAction {
    &getNumber;
    &getEnvVar;

    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }
    
    &GET_COOKIE;                
                 
    # ȸԽ 
    if($gUserType eq "type_member") {
    	        
         #  ȯ漳 ޴
         if($FORM{'action'} eq "admin_login") {
            if($COOKIE{'ROOTADMIN'} eq $gSupervisor_Password) {
                  &showConfigForm;         		
            }
            else {
                 &showAdminLogin;
            }           	
         }       
         elsif($FORM{'action'} eq "show_config_form") {       	
      	&checkAdminPassword;
                &showConfigForm;
         }      
         elsif($FORM{'action'} eq "config") {
                   &updateEnvVar;
         }
         # αǾ  α 
         elsif(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
               &checkMember;           
         }
         # α 밡 Լ
         else {
               if($FORM{'action'} eq "r") {	
                   &readData;
               } 
               elsif($FORM{'action'} eq "show_user_input_form") {
                   &showUserInputForm;
               }
               elsif($FORM{'action'} eq "write") {
                   &writeData;
               } 
               elsif($FORM{'action'} eq "download") {
                   &downloadData;
               }                
               elsif($FORM{'action'} eq "delete") {
                   &checkUserPassword;
                   &deleteData;
               } 
               elsif($FORM{'action'} eq "show_content") {
                    &addHitCounter;
                    &readData;
               } 
               elsif($FORM{'action'} eq "search") {
                    &getNumber;  
                    &HTMLHeader;
                    &TitleMenu;              	                               
                    &searchData;
               }                       
               elsif($FORM{'action'} eq "show_update_form") {
                   &checkUserPassword;
                   &showUpdateForm;
               } 
               elsif($FORM{'action'} eq "update") {
                   &updateData;
               } 
               elsif($FORM{'action'} eq "users_login") {
                   &showUsersLogin;
               }
               else {
                  exit;
               }
          }
    }
    # ϹݰԽ 
    else {
           if($FORM{'action'} eq "r") {	
               &readData;
           } 
           elsif($FORM{'action'} eq "show_user_input_form") {
               &showUserInputForm;
           }
           elsif($FORM{'action'} eq "write") {
               &writeData;
           } 
           elsif($FORM{'action'} eq "download") {
               &downloadData;
           }                           
           elsif($FORM{'action'} eq "delete") {
               &checkUserPassword;
               &deleteData;
           } 
           elsif($FORM{'action'} eq "show_content") {
                &addHitCounter;
                &readData;
           }
           elsif($FORM{'action'} eq "search") {
                &getNumber;  
                &HTMLHeader;
                &TitleMenu;              	               
                &searchData;
           }            
           elsif($FORM{'action'} eq "show_update_form") {
               &checkUserPassword;
               &showUpdateForm;
           } 
           elsif($FORM{'action'} eq "update") {
               &updateData;
           } 
           elsif($FORM{'action'} eq "users_login") {
               &showUsersLogin;
           }
           elsif($FORM{'action'} eq "admin_login") {
                  if($COOKIE{'ROOTADMIN'} eq $gSupervisor_Password) {
                     &showConfigForm;         		
                  }
                  else {
                     &showAdminLogin;
                  }           	
           }
           elsif($FORM{'action'} eq "show_config_form") {
              &checkAdminPassword;
              &showConfigForm;
           }
           elsif($FORM{'action'} eq "config") {
              &updateEnvVar;
           }
           else {
              exit;
           }
     }       
}

##########################################################################
# ȸ Խ  üũ
##########################################################################
sub checkMember {	
       &GET_COOKIE;
       
       if (!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
                   print "Content-type: text/html\n\n";
                   print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Board $gVerBoard
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";
                   print "<html><head>\n";
                   print "<title>Beomdori's Board $gVerBoard</title>\n";    
                   print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
                   print "<style type='text/css'>\n";
                   print "<!--\n";	
                   print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
                   print "-->\n";
                   print "</style>\n" ;    
                   print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n\n";		
	   print "<script language=JavaScript>
		function IDPasswdWindow(URL) {
		  window.open(URL,'IDPasswdWindow','resizable=no,scrollbars=no,status=0,width=220, height=170');
		}
		function RegisterWindow(URL) {
	 	  window.open(URL,'RegisterWindow','resizable=no,scrollbars=no,status=0,width=500, height=560');
		}
		</script>
		</head>";

                    print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return true'>\n";
                    print "<center><br><br>\n";    
                             if($gTitleUse eq "YES" || $gTitleUse eq "") {
                               print "<br><img src=$gIMG_Board/title.gif border=0><p>\n";
                             }                    
	    print "<center>
		<TABLE WIDTH=220 align=center border=0 background=$gIMG_Board/m_bg.gif>
		<TR>
		 <TD ALIGN=center colspan=3><br><b>ȸ Խ</b><br><br></td></tr>
		 <tr><td width=80 align=right>
		<FORM ACTION=$gCGI_Login METHOD=post name=loginForm>
		<INPUT TYPE=hidden NAME=action VALUE=login_data>
		<INPUT TYPE=hidden NAME=db VALUE=$FORM{'db'}>		
		ID :&nbsp;</td>
		<td width=100 align=right> <INPUT TYPE=TEXT CLASS=INPUT NAME=MEMBER_ID size=13 style=\"IME-MODE: inactive\"></td>
                                </tr>
                                <tr><td align=right>
		Password :&nbsp;</td>
 		<td align=right><INPUT TYPE=PASSWORD CLASS=INPUT NAME=MEMBER_PW size=13></td>
                                <td width=40></td>
		</tr>
		<tr><td colspan=2 align=right>
		<INPUT TYPE=SUBMIT CLASS=INPUT VALUE=α>
		</FORM><br><br></td><td></td>
		</TABLE></DIV>";

		print "<DIV ALIGN=center>
		<TABLE WIDTH=$TABLE_WIDTH>
		<TR><TD ALIGN=CENTER>
		<br><a href=javascript:RegisterWindow('$gCGI_Member')>ȸ</a> / 
		<a href=javascript:IDPasswdWindow('$gCGI_Login?action=search_form')> ̵, нн</a>
		</TD></TR></TABLE></DIV>
                                <script language=javascript>document.loginForm.MEMBER_ID.focus();</script>
		";
                     &HTMLFooter;

        }    
}

##########################################################################
# Ű б
##########################################################################
sub GET_COOKIE {	
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
}
	
##########################################################################
#  ȭ  ų DB 丮 ʱȭ
##########################################################################
sub getNumber {
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);

        open(HANDLE,"<$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        if($gNoOfData != $#datum) {
            $gNoOfData = $#datum;
            &putNumber;
        }
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/data",0777);

        open(HANDLE,">$gBaseDIR/$gDatFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

##########################################################################
# ȣ 
##########################################################################
sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

##########################################################################
# bdr_board ȯ漳 оδ.
##########################################################################
sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        
        $gDesignType = $datum[12];  # 0 or 1              
        $gUserType = $datum[20];      # Ÿ : Ϲ type_normal, ȸ type_member
                
        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTableWidth = $datum[5];
        $gTableBgColor = $datum[21];
        $gTableTextColor = $datum[15];
        $gActiveTableColor = $datum[14];
        $gTextColor = $datum[17];
        $gTitleUse = $datum[11];        
      
        $gAlignType = $datum[26];               # Display Ĺ 
        $gFList = $datum[3];                         # Ϻ̱

        $gFileLink = $datum[28];                   # ϸũ
        $gFileUpload = $datum[29];              # Ͼε
        $gMaxFileSize = $datum[30];            # Ͼε ִũ
        
        $gTableTitleBgColor = $datum[31];
        $gTableTitleTextColor = $datum[32];
        $gMinmumHit = $datum[33];              

               
        $gTempURL2 = $datum[4];  
        $gTempColor1 = $datum[8];
        $gTempColor2 = $datum[9];
        $gTempColor3 = $datum[18];        
        $gTempColor4 = $datum[16];
        $gTempColor5 = $datum[22];
        $gTempColor6 = $datum[23];
        $gTempColor7 = $datum[10];                
        $gTempColor8 = $datum[27];                        
        $gTempColor9 = $datum[13];        
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];
        $gTempYesOrNo3 = $datum[25];
        $gTempYesOrNo4 = $datum[36];        
        $gTempYesOrNo5 = $datum[35];                
        $gTempYesOrNo6 = $datum[34];
        chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 

        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/board/bg.gif";

        $gDesignType = "board";
        $gUserType = "type_normal";                  # Ÿ : Ϲ type_normal, ȸ type_member
                        
        $gTableWidth = "95%";
        $gTableBgColor = "#ffffff";
        $gTableTextColor = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";
        $gTitleUse = "YES";           
        
        $gRecPerPage = "10";
        $gListNumber = "5";
        $gAlignType = "center";
        $gFList = "show"; 

        $gFileLink = "hide";
        $gFileUpload = "hide";
        $gMaxFileSize = "5000";       
                
        $gTableTitleBgColor = "#2d6096";
        $gTableTitleTextColor = "#000000";
        
        $gMinmumHit = "50";                

        
        $gTempColor1 = "#000000";
        $gTempColor2 = "#000000";        
        $gTempColor3 = "#000000";        
        $gTempColor4 = "#000000";        
        $gTempColor5 = "#000000";
        $gTempColor6 = "#000000";
        $gTempColor7 = "#000000";                
        $gTempColor8 = "#494949";                        
        $gTempColor9 = "#ffffff";                
        $gTempYesOrNo1 = "YES";
        $gTempYesOrNo2 = "YES";
        $gTempYesOrNo3 = "YES";
        $gTempYesOrNo4 = "YES";
        $gTempYesOrNo5 = "YES";        
        $gTempYesOrNo6 = "NO";
        $gTempURL2 = "";      
        &putEnvVar;
    }
}

##########################################################################
# bdr_board ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "|$gBackColor|$gBackImgURL|$gFList|$gTempURL2|$gTableWidth|$gRecPerPage|$gListNumber|$gTempColor1|$gTempColor2|$gTempColor7|$gTitleUse|$gDesignType|$gTempColor9|$gActiveTableColor|$gTableTextColor|$gTempColor4|$gTextColor|$gTempColor3|$gTempYesOrNo1|$gUserType|$gTableBgColor|$gTempColor11|$gTempColor12|$gTempYesOrNo2|$gTempYesOrNo3|$gAlignType|$gTempColor8|$gFileLink|$gFileUpload|$gMaxFileSize|$gTableTitleBgColor|$gTableTitleTextColor|$gMinmumHit|$gTempYesOrNo6|$gTempYesOrNo5|$gTempYesOrNo4|\n";
    close(HANDLE);
}

##########################################################################
# Ÿ оδ.
##########################################################################
sub readData {
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &HTMLHeader;
   
    if($FORM{'action'} eq "show_content") {      # 뺸
       &readFileContent;

       if($gFList eq "show") {                               # Ʈ ½
          if($FORM{'word'}) {                               # ˻ ´ܾ 
             &TitleMenu;       	
             &searchData;
          }         
          else {
             &TitleMenu;       
             &readIndexFile;
          }
       }       
    }
    else {                                                           # Ϻ
       &TitleMenu;    	
       &readIndexFile;
     }

    &MenuButton;
    
    &showSearchForm;    
    
    &HTMLFooter;
}

##########################################################################
# ָ޴ 
##########################################################################
sub TitleMenu {
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 align=center>\n";

    if(($gFileUpload eq "show") || ($gFileLink eq "show")) {      # ڷ
       if(($FORM{'action'} eq "search") || ($FORM{'word'})) {
          print "<tr><td align=left colspan=5></td>\n";
       }
       else {
          print "<tr><td align=left colspan=5>Total : <font color=red>$gNoOfData</font> Articles, <font color=#ff0000>$gCurPage</font>/$gTotPage Total Pages</td>\n";
       } 

       if($gUserType eq "type_member") {
         print "<td align=right><a href=$gCGI_Member?action=modify_form><IMG SRC=$gIMG_Board/Info.gif border=0></a> <a href=$gCGI_Login?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Board/logout.gif border=0></a></td></tr>\n";
       }
       else {
         print "<td align=right><a href=$gCGI_Member><IMG SRC=$gIMG_Board/register.gif border=0></a></td></tr>\n";    
       }
    
       print "<tr bgcolor=$gTableTitleBgColor>\n";
       print "<td align=center valign=middle width=5% height=21><img src=$gIMG_Board/no.gif border=0></td>\n";
       print "<td align=center valign=middle width=56%><img src=$gIMG_Board/subject.gif border=0></td>\n";
       print "<td align=center valign=middle width=10%><img src=$gIMG_Board/name.gif border=0></td>\n";
       print "<td align=right valign=middle width=7%><img src=$gIMG_Board/down.gif border=0></td>\n";              
       print "<td align=right valign=middle width=7%><img src=$gIMG_Board/read.gif border=0></td>\n";       
       print "<td align=center valign=middle width=15%><img src=$gIMG_Board/date.gif border=0></td>\n";                
       print "</tr>\n";
       print "</table>\n";
    }
    else {                                                     # Խ
       if(($FORM{'action'} eq "search") || ($FORM{'word'})) {
          print "<tr><td align=left colspan=4>&nbsp;</td>\n";
       }
       else {
          print "<tr><td align=left colspan=4>Total : <font color=red>$gNoOfData</font> Articles, <font color=#ff0000>$gCurPage</font>/$gTotPage Total Pages</td>\n";    	
       } 

       if($gUserType eq "type_member") {
         print "<td align=right><a href=$gCGI_Member?action=modify_form><IMG SRC=$gIMG_Board/Info.gif border=0></a> <a href=$gCGI_Login?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Board/logout.gif border=0></a></td></tr>\n";
       }
       else {
         print "<td align=right><a href=$gCGI_Member><IMG SRC=$gIMG_Board/register.gif border=0></a></td></tr>\n";    
       }
    
       print "<tr bgcolor=$gTableTitleBgColor>\n";
       print "<td align=center valign=middle width=5% height=21><font color=$gTableTitleTextColor><img src=$gIMG_Board/no.gif border=0></font></td>\n";
       print "<td align=center valign=middle width=63%><font color=$gTableTitleTextColor><img src=$gIMG_Board/subject.gif border=0></font></td>\n";
       print "<td align=center valign=middle width=10%><font color=$gTableTitleTextColor><img src=$gIMG_Board/name.gif border=0></font></td>\n";
       print "<td align=right valign=middle width=7%><font color=$gTableTitleTextColor><img src=$gIMG_Board/read.gif border=0></font></td>\n";           	
       print "<td align=center valign=middle width=15%><font color=$gTableTitleTextColor><img src=$gIMG_Board/date.gif border=0></font></td>\n";                
       print "</tr>\n";
       print "</table>\n";    	
    }
}

##########################################################################
# ޴
##########################################################################
sub MenuButton {
    print "<br><table border=0 width=$gTableWidth border=0 cellspacing=1 cellpadding=2 align=$gAlignType>\n";
    print "<tr>\n";
    print "<td align=left align=top width=20%>\n";
    print "<a href=$gCGI_Board?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIMG_Board/admin.gif border=0 alt=\"Administrator\"></a> \n";
    print "<a href=$gCGI_Board?db=$FORM{'db'}&action=show_user_input_form><img src=$gIMG_Board/write.gif border=0 alt=\"Write\"></a>\n";
    print "</td>\n";
    print "<td align=center width=60%>\n";
    &FastGo;	    
    print "</td>\n";
    print "<td align=right align=top width=20%>\n";
    
    $term = 1;
    $f = 1;
    $l = $term;
    
    while ($f <= $gTotPage) {
      if(($f <= $gCurPage) && ($gCurPage <= $l)) {
         $prevp = $f - 1;
        if ($prevp > 0) {
          print "<a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIMG_Board/previous.gif border=0 alt=\"Previous Page\"></a> ";
        }
        else {
          print "<img src=$gIMG_Board/previous_n.gif border=0 alt=\"First Page\"> ";
        }
        
       $nextp = $l + 1;
       if($nextp <= $gTotPage) {
         print "<a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIMG_Board/next.gif border=0 alt=\"Next Page\"></a>";
       }
       else {
         print "<img src=$gIMG_Board/next_n.gif border=0 alt=\"Last Page\">";
       }
     }
     $f = $f + $term;
     $l = $l + $term;
   }

    print "</td></tr>\n";
    print "</table>\n";
}

##########################################################################
# ȭ鿡 Ʈ 
##########################################################################
sub readIndexFile {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    &getDate;
    
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
   
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
    print "<tr><td>\n";
      
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

         if($actual_number > 0) {
             $date_length = length($date);
             $short_date = substr($value[5],0,20);
                          
             print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
             print "<tr onMouseOver=this.style.backgroundColor=\"#f5f5f5\" onMouseOut=this.style.backgroundColor=\"\">\n";
             print "<td align=center valign=middle width=5%>$actual_number</td>\n"; #ȣ
             
             $blank = "";
             if($value[0] eq '1') {
               $blank = "&nbsp;&nbsp;";
             }
             elsif($value[0] eq '2') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             elsif($value[0] eq '3') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             elsif($value[0] eq '4') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
             }                          
             
             if($value[5] eq $date) {                                         #   
                if(($gFileUpload eq "show") || ($gFileLink eq "show")) {       # ڷ
                  if($value[12] ne "") {       # ڷ
                     $Filetype = &GetFileType($value[12]);                	                	
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; # 
                  }
                  elsif(($value[12] eq "") && ($value[3] ne "")) {     # ڷ
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; # 
                  }
                  else {
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; #                   	
                  }
                }
                else {                   # Խ
                   print "<td align=left valign=middle width=63%\">&nbsp;$blank<img src=\"$gIMG_Board/old.gif\" border=0>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; #                 	                
                }
             }
             else {                                                                       #   찡 ƴ 
                if(($gFileUpload eq "show") || ($gFileLink eq "show")) {       # ڷ
                  if($value[12] ne "") {       # ڷ
                     $Filetype = &GetFileType($value[12]);                	                	
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a></td>\n"; # 
                  }
                  elsif(($value[12] eq "") && ($value[3] ne "")) {     # ڷ
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a></td>\n"; # 
                  }
                  else {
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a></td>\n"; #                   	
                  }
                }
                else {                   # Խ
                   print "<td align=left valign=middle width=63%\">&nbsp;$blank<img src=\"$gIMG_Board/old.gif\" border=0>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a></td>\n"; #                 	                
                }
             }
             
             if($value[4] eq "") {
                print "<td align=center valign=middle width=10%>$value[2]</td>\n";   # ̸
             }
             else {
             	if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                   print "<td align=center valign=middle width=10%><a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[2]</a></td>\n";   # ̸                                	             	
                }
                else {
                   print "<td align=center valign=middle width=10%><a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\">$value[2]</a></td>\n";   # ̸                
                }
             }
             
             if(($gFileUpload eq "show") || ($gFileLink eq "show")) {
             	if(($value[10]eq "") && ($value[3]eq "")){          # v1.0 ȣȯ
             	   $value[10] = 0;
             	   $value[10] = 0;
                }
                if($value[10] >= $gMinmumHit) {
                   print "<td align=right valign=middle width=7%><font color=red>$value[10]</font>&nbsp;</td>\n"; # ٿ
                }
                else {
                   print "<td align=right valign=middle width=7%>$value[10]&nbsp;</td>\n"; # ٿ                	
                }
             }

             if($value[11] >= $gMinmumHit) {
                print "<td align=right valign=middle width=7%><font color=red>$value[11]</font>&nbsp;</td>\n"; # ȸ
             }
             else {
                print "<td align=right valign=middle width=7%>$value[11]&nbsp;</td>\n"; # ȸ
             }                          
             
             print "<td align=center valign=middle width=15%>$value[5]</td>\n"; # 
             print "</tr>\n";
             if(($gFileUpload eq "show") || ($gFileLink eq "show")) {
                print "<tr><td colspan=6 width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";
             }
             else {
                print "<tr><td colspan=5 width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";             	
             }
             print "</table>\n";
      }
   }
    print "</td></tr></table>\n";
   
   unless($gNoOfData) {
        print "&nbsp;<table width=$gTableWidth border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ  ϴ.</font></b></td></tr></table>\n";
    }
}

##########################################################################
# ȭ鿡 Ŭ  
##########################################################################
sub readFileContent {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    &getDate;
    
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
   
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
    print "<tr><td>\n";
      
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

         if($actual_number > 0) {
             $date_length = length($date);
             $short_date = substr($value[5],0,20);
              
               if($FORM{'cp'} eq "content") {     # ˻  ˻ ܾ  ǥ
                  if($FORM{'word'}) {        
                     $value[6] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                  }
               }
               elsif($FORM{'cp'} eq "subject") {   # ˻  ˻ ܾ  ǥ
                  if($value[9] =~ /$FORM{'word'}/i) {
                     $value[9] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                }
               }
               elsif($FORM{'cp'} eq "name") {      # ̸˻  ˻ ܾ  ǥ
                  if($value[2] =~ /$FORM{'word'}/i) {
                     $value[2] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                }
               }
               elsif($FORM{'cp'} eq "all") {      # ü˻  ˻ ܾ  ǥ
                  if($FORM{'word'}) {        
                     $value[6] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                  }               
                  if($value[2] =~ /$FORM{'word'}/i) {
                     $value[2] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                  }
                  if($value[9] =~ /$FORM{'word'}/i) {
                     $value[9] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                  }                  
               }
               
              if($FORM{'n'} eq $i) {
                print " <table border=0 cellpadding=0 cellspacing=0 width=100% align=left>\n";
                print "  <tr><td align=left valign=top colspan=2>\n";
                print "   <table border=1 cellpadding=0 cellspacing=0 width=100% align=left bordercolorlight=\"\" bordercolordark=$gActiveTableColor>\n";
                print "    <tr><td>\n";                
                print "     <table border=0 bgcolor=$gTableBgColor cellpadding=3 cellspacing=0 width=100% align=left>\n";
                print "       <tr bgcolor=$gTableTitleBgColor><td align=left><img src=$gIMG_Board/speak.gif border=0>&nbsp;<font color=\"$gTableTitleTextColor\">$value[9]</font></td><td align=right><font color=\"$gTableTitleTextColor\">ȸ : $value[11]&nbsp;</td></tr>";       

                if($value[4] eq "") {      # ̸ 
                  if($value[8] eq "") {    # Ȩ 
                     print "<tr><td align=left colspan=2> ۼ : $value[2] </td></tr>\n";                
                  }
                  else {
                     print "<tr><td align=left colspan=2> ۼ : $value[2] <a href=$value[8] target=\"_blank\"><img src=$gIMG_Board/home.gif border=0 alt=\"$value[8]\"></a></td></tr>\n";               
                  }
                }
                else {  # ̸ 
                  if($value[8] eq "") { #Ȩ 
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "<tr><td align=left colspan=2> ۼ : $value[2] <a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a></td></tr>\n";             	     
                     }
                     else {
                        print "<tr><td align=left colspan=2> ۼ : $value[2] <a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a></td></tr>\n";             	     
                     }                  
                  }
                  else {
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "<tr><td align=left colspan=2> ۼ : $value[2] <a href=$value[8] target=\"_blank\"><img src=$gIMG_Board/home.gif border=0 alt=\"$value[8]\"></a> <a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a></td></tr>\n";
                     }
                     else {
                        print "<tr><td align=left colspan=2> ۼ : $value[2] <a href=$value[8] target=\"_blank\"><img src=$gIMG_Board/home.gif border=0 alt=\"$value[8]\"></a> <a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a></td></tr>\n";
                     }                                    	
                  }
                }
                
                print "    <tr><td height=3 width=100% background=$gIMG_Board/dot.gif colspan=2> </td></tr>\n";
               
                # ε ȭ 
                if($value[12]) {                		
                  $Filetype = &GetFileType($value[12]);
                  print "    <tr><td colspan=2><img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$CGI_Board?db=$FORM{'db'}&action=download&l=$value[1]&d=$i&file=$value[12] target=_blank>$value[12]</a></td></tr>\n";
                }
                # ϸũ 
                if($value[3]) {
                  @FILENAME = split(/\//, $value[3]);
	  $file_name = $FILENAME[$#FILENAME];                	
                  $Filetype = &GetFileType($value[3]);
                  print "    <tr><td colspan=2><img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$CGI_Board?db=$FORM{'db'}&action=download&l=$value[1]&d=$i&file=$value[3] target=_blank>$file_name (LINK)</a></td></tr>\n";
                }
                if($value[12] || $value[3]) {
                  print "    <tr><td height=3 width=100% background=$gIMG_Board/dot.gif colspan=2></td></tr>\n";                                   
                }        
                                     
                print "    <tr><td colspan=2><font color=$gTableTextColor>$value[6]</font><br>\n";
                print "     <div align=right><font size=1 color=aaaaaa>$value[7]</font>&nbsp;&nbsp;</div>\n";
                print "    </td></tr></table>\n";
                print "   </table>\n";
                print "   </td></tr>\n";
                print "  <tr><td align=left valign=top height=50><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Board/list.gif border=0 alt=\"List\"></a></td>
                                <td align=right valign=top height=50><a href=$gCGI_Board?db=$FORM{'db'}&action=show_user_input_form&p=$FORM{'p'}&c=show_update_form&n=$FORM{'n'}&l=$value[1]><img src=$gIMG_Board/reply.gif border=0 alt=\"Reply\"></a><a href=$gCGI_Board?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Board/mod.gif border=0 alt=\"Modify\"></a><a href=$gCGI_Board?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Board/del.gif border=0 alt=\"Delete\"></a></td></tr>\n";
                print " </table>\n";
              }
         }
   }
    print "</td></tr></table>\n";
} 

##########################################################################
# htmlӸ
##########################################################################
sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Board $gVerBoard
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";
    print "<html>\n<head>\n";
    print "<title>Beomdori's Board $gVerBoard</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<style type='text/css'>\n";
    print "<!--\n";	
    print " BODY {background:url(\"$gBackImgURL\") $bgcolor fixed no-repeat 98% 98%}\n";
    print "-->\n";
    print "</style>\n" ;    
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n\n";
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";
    print "<script language=javascript>\n";
    print "function clearField(field){ if (field.value == field.defaultValue) {  field.value = ''; } }\n";
    print "function checkField(field){ if (field.value == '') { field.value = field.defaultValue; } }\n";
    print "</script>\n\n";
    print "<SCRIPT language=JavaScript>\n";
    print "function smail(URL) {\n";
    print "window.open(URL,'smail','left=200, top=200, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, width=309, height=338');\n";
    print "}</SCRIPT>\n\n";
    print "</head>\n\n";    

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return true'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return ture'><br>\n";
    }

    print "<center><br>\n";    
    
    print "<table width=$gTableWidth border=0 align=$gAlignType><tr><td>\n";    
    
    if($gTitleUse eq "YES" || $gTitleUse eq "") {
       print "<br><center><img src=$gIMG_Board/title.gif border=0></center><p>\n";
    }
}

##########################################################################
# html
##########################################################################
sub HTMLFooter {
    &copyright;
    print "</td></tr></table>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

##########################################################################
# ۱
##########################################################################
sub copyright {
       print "\n<center><br><br><a href=\"http://beomdori.x-y.net\" target=\"_blank\"><font color=\"#444444\" size=1 face=Tahoma>Created by <font color=\"#444444\" size=1 face=Tahoma>Beomdori</font></a></font><br><br><br>\n";
}

##########################################################################
# ٿ 
##########################################################################
sub FastGo {
       print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=top><tr><td align=center>\n";
       $term = $gListNumber;
       $f = 1;
       $l = $term;
       
       while($f <= $gTotPage) {
             if(($f <= $gCurPage) && ($gCurPage <= $l)) {
                  $prevp = $f - 1;

                 if ($prevp > 0) {
                      print "<a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$prevp>[ ]</a>..";
                 }
                  
                 if($l <= $gTotPage) {
	     for($page = $f; $page <= $l; $page++) {
	         if($page == $gCurPage) {
                            print "<font color=$gTableTextColor>[<font color=blue><b>$page</b></font>]</font>";
	         }
                         else {
                            print "<a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$page>[$page]</a>";
                         }
                    }
                 }
                 else {
                    for($page = $f; $page <= $gTotPage; $page++) {
	         if($page == $gCurPage) {
                            print "<font color=$gTableTextColor>[<font color=blue><b>$page</b></font>]</font>";
                         }
                         else {
                            print "<font color=$gTextColor><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$page>[$page]</font></a>";
                         }
                    }
                 }
                 $nextp = $l + 1;
                 
  	 if($nextp <= $gTotPage) {
                    print "..<a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$nextp>[ ]</a>";
                 }
           }
           $f = $f + $term;
           $l = $l + $term;
     }
     print "</td></tr></table>\n";
}

##########################################################################
#  ۾ 
##########################################################################
sub showUserInputForm {
    local($data,$subject,$content,$name,$value,$fileupload);
    local(@value,@cookies);
    
    &GET_COOKIE;
 
    &HTMLHeader;

    if($FORM{'l'}) {         #   
       open(HANDLE, "$gBaseDIR/data/$FORM{'l'}.cgi");
          $data = <HANDLE>;
       close(HANDLE);
        
       @value = split(/\|/,$data);
       $subject = "Re: $value[9]";
       $content = "&gt;$value[6]\n";
       $content =~ s/<br>/\n&gt;/g;
       $content =~ s/<p>/\n&gt;\n&gt;/g;
    }
       
    if($gUserType eq "type_member") {             	
       print "<form method=post name=inputForm action=$gCGI_Board enctype=multipart/form-data>\n";    
       print "<br><table border=0 cellspacing=0 cellpadding=0 align=center>\n";
       print "<tr><td>\n";

       print "<table border=0 cellspacing=1 cellpadding=2>\n";    
       print "<input type=hidden name=db value=$FORM{'db'}>\n";
       print "<input type=hidden name=action value=write>\n";
       print "<input type=hidden name=p value=$FORM{'p'}>\n";
       print "<input type=hidden name=n value=$FORM{'n'}>\n";
       print "<input type=hidden name=l value=$FORM{'l'}>\n";
    
       print "<input type=hidden name=passwd value=$COOKIE{'MEMBER_PW'}>\n";
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       print "<input name=name type=hidden value='$COOKIE{'MEMBER_NAME'}'><font color=777777 face=\'\'>$COOKIE{'MEMBER_NAME'}</font></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value='$COOKIE{'MEMBER_EMAIL'}' type=hidden><font color=777777 face=\'\'>$COOKIE{'MEMBER_EMAIL'}</font></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=hidden value='$COOKIE{'MEMBER_HOMEPAGE'}'><font color=777777 face=\'\'>$COOKIE{'MEMBER_HOMEPAGE'}</font></td></tr>\n";     
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       if($subject eq "") {       
          print "<input type=text name=subject value='' class=text size=40 maxlength=40> <input type=checkbox name=html value=enable style=\"background-color:$gBackColor;border:0\">html</td></tr>\n";
       }
       else {
          print "<input type=text name=subject value=\"$subject\" class=text size=40 maxlength=40> <input type=checkbox name=html value=enable style=\"background-color:$gBackColor;border:0\">html</td></tr>\n";       	
       }       
       print "<input type=hidden name=ip value=\"$value[7]\">\n";                              # Ӽ : ip    
       print "<input type=hidden name=date value=\"$value[5]\">\n";                          # Ӽ : ¥            
       print "</td></tr>\n";         
       if($content eq "") {
          print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment></textarea></td>\n";
       }
       else {
         print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment>$content</textarea></td>\n";       	
       }       
       print "</tr>\n";
       if($gFileLink eq "show") {
          print "<tr><td align=right valign=top><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value='http://' class=text size=63>$value[3]</td></tr>\n";
       }
       if($gFileUpload eq "show") {
          print "<tr><td align=right valign=top><span class=cls><b>File Upload</b></span></td><td><input type=file name=fileupload value='' size=44 class=file></td></tr>\n";
       }    	              
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       if($subject eq "") {       
          print "<script language=\"javascript\">document.inputForm.subject.focus();</script>\n";
       }
       else {
          print "<script language=\"javascript\">document.inputForm.content.focus();</script>\n";
       }              
   }
   else {   # Ϲݸ     
       print "<form method=post name=inputForm action=$gCGI_Board enctype=multipart/form-data>\n";    
       print "<br><table border=0 cellspacing=0 cellpadding=0 align=center>\n";
       print "<tr><td>\n";

       print "<table border=0 cellspacing=1 cellpadding=2>\n";    
       print "<input type=hidden name=db value=$FORM{'db'}>\n";
       print "<input type=hidden name=action value=write>\n";
       print "<input type=hidden name=p value=$FORM{'p'}>\n";
       print "<input type=hidden name=n value=$FORM{'n'}>\n";
       print "<input type=hidden name=l value=$FORM{'l'}>\n";
    
       print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
       print "<td><input type=password name=passwd size=20 maxlength=16 value='' class=text></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       print "<input name=name type=text size=20 value='' class=text maxlength=6>\n";
       print "</td></tr>\n";    
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value='' type=text size=40 class=text></td></tr>\n";                    
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value='http://' size=40 class=text></td></tr>\n";     
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       if($subject eq "") {       
          print "<input type=text name=subject value='' class=text size=40 maxlength=40> <input type=checkbox name=html value=enable style=\"background-color:$gBackColor;border:0\">html</td></tr>\n";
       }
       else {
          print "<input type=text name=subject value=\"$subject\" class=text size=40 maxlength=40> <input type=checkbox name=html value=enable style=\"background-color:$gBackColor;border:0\">html</td></tr>\n";       	
       }
       print "<input type=hidden name=ip value=\"$value[7]\">\n";                                # Ӽ : ip    
       print "<input type=hidden name=date value=\"$value[5]\">\n";                              # Ӽ : ¥            
       print "</td></tr>\n";         
       if($content eq "") {
          print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment></textarea></td>\n";
       }
       else {
         print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment>$content</textarea></td>\n";       	
       }
       print "</tr>\n";
       if($gFileLink eq "show") {
          print "<tr><td align=right valign=top><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value='http://' class=text size=63>$value[3]</td></tr>\n";
       }
       if($gFileUpload eq "show") {
          print "<tr><td align=right valign=top><span class=cls><b>File Upload</b></span></td><td><input type=file name=fileupload value='' size=44 class=file></td></tr>\n";
       } 
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.inputForm.passwd.focus();</script>\n";	
   }    
    
    &HTMLFooter;
}

################################################################################[ε ]
sub saveFile {
       if($FORM{'fileupload'}) {
		local($t);
		local(@x,@y);
		$UpFile = $FORM{'fileupload'};
				
		@x = split(/\"/, $S_RealFile);
		@y = split(/\\/,$x[3]);
		$t = @y;
		
		$fname = ($y[$t-1]);
		
		@F_N = split(/\./, $fname);
		if($F_N[$#F_N] =~ /htm|ph/i ) {
			$msg = "˼մϴ. PHP  Ȼ εϽ  ϴ. Ŀ ε ּ"; 
			Alert();
		}		
			
		if(-e "$gUploadDIR/$fname") {
			$msg = "εϽ  ̹ ε丮 մϴ."; 
			Alert();
		}
		else {
			if(length($FORM{'fileupload'}) > $gMaxFileSize*1024) {
				$msg = " ũⰡ ($gMaxFileSize kb) Ůϴ."; 
				Alert();
			}
			else{
				local($SAVE_UPFILE);
				$SAVE_UPFILE = "$gUploadDIR/$fname";
				open(HANDLE,">$SAVE_UPFILE");
				 binmode HANDLE;
				 print HANDLE $UpFile;
				close HANDLE;
			}
		}
	} 
}

##########################################################################
# ȭϿ Է  Ѵ.
##########################################################################
sub writeData {
    &getNumber;
    &getVariable;
   
    &makeCryptPassword if($passwd);
    &saveFile if($FORM{'fileupload'});         # ȭ ε
    &makeNewFile;
    &appendIndexFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Board $gVerBoard
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";
    print "<html>\n";
    print "<head>\n<title>Beomdori's Board $gVerBoard</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    
    print "<meta http-equiv=refresh content=\"0;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
# Է  ´
##########################################################################
sub getVariable {
# ȣ	
    if(($FORM{'passwd'}) || ($FORM{'OldPassword'})) {
        $passwd = "$FORM{'passwd'}";
    }
    else {
        $msg = "ȣ ݵ ּ."; 
        Alert();
    }
    
# ̸
    unless($FORM{'name'} =~ /^\s*$/) {
        $name = "$FORM{'name'}";
        $name =~ s/\r\n/<br>/g;
    }
    else {
        $msg = "̸ ݵ ּ."; 
        Alert();
    }

# 
    if($FORM{'content'}) {
       $content = "$FORM{'content'}";
        if($FORM{'html'} ne "enable") {
            $content =~ s/</&lt;/g;
            $content =~ s/>/&gt;/g;
            $content =~ s/"/&quot;/g;
            $content =~ s/\|/&#124;/g;
        }
        $content =~ s/\r\n\r\n/<p>/g;
        $content =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        Alert();
    }

# 
    if($FORM{'subject'}) {
       $subject = "$FORM{'subject'}";
       $subject =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        Alert();
    }
        
# ̸
    if($FORM{'email'}) {
        $email = "$FORM{'email'}";
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "";
    }
    
# Ȩ
    if($FORM{'homepage'}) {
       if($FORM{'homepage'} eq 'http://') {
       	  $homepage = "";
       }
       else {
          $homepage = "$FORM{'homepage'}";
          $homepage =~ s/\|/&#124;/g;
        }
    }

# ϸũ
    if($FORM{'filelink'}) {    	
       if($FORM{'filelink'} eq 'http://') {
       	  $filelink = "";
       }
       else {
          $filelink = "$FORM{'filelink'}";
          $filelink =~ s/\|/&#124;/g;
        }
    }

# Ͼε
    if($FORM{'fileupload'}) {    	

        $fname = "$FORM{'fileupload'}";
    }
    else {
        $fname = "";
    }
    
# ¥
    if($FORM{'date'} eq "") {
        &getDate;            
    }
    else {
        $date = "$FORM{'date'}";
        $date =~ s/\|/&#124;/g;
    }

# IP    
    if($FORM{'ip'} eq "") {
        $ip = $ENV{'REMOTE_ADDR'};
    }
    else {
        $ip = "$FORM{'ip'}";
        $ip =~ s/\|/&#124;/g;
    }        
}

##########################################################################
# ¥
##########################################################################
sub getDate {     
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
	$month=($mon+1);
	if($year ne "99"){
		if($year > 100){
			$year=($year-100)+2000;
		}
		elsif($year < 10){
			$year=2000+$year;	
		}
		else{
		$year="2000";
		}
        }
        else {
	   $year="1999";
        }
	if($month < 10) { $month="0$month";}
	if($mday < 10) { $mday="0$mday";}
	if($min < 10) { $min="0$min";}
	if($sec < 10) { $sec="0$sec";}
	
                $date = "$year-$month-$mday"; 
                $d = "$year$month$mday";
}  

##########################################################################
# ˻
##########################################################################
sub showSearchForm {
    print "\n<form method=post name=searchForm action=$gCGI_Board>\n";
    print "<table border=0 width=300 cellspacing=0 cellpadding=1 align=center>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=search>\n";
    print "<input type=hidden name=p value=$gCurPage>\n";
    print "<tr>\n";
    print "<td align=center valign=top>\n";
    print "<select name=cp>
    	    <option value=subject selected>&nbsp;
    	    <option value=name≯&nbsp;
    	    <option value=content>&nbsp;
    	    <option value=all>ü&nbsp;
           </select>";
    print "<input type=text size=15 name=word maxlength=15 style=\"height:16pt\">\n";
    print "<input type=submit value=\" \" style=\"height:16pt\">\n";    
    print "</table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.searchForm.word.focus();</script>\n";    
}

##########################################################################
# ˻ϱ
##########################################################################
sub searchData {
    local($data);
    local(@datum,@value);    

    unless($FORM{'word'}) {
        print "<center><font color=red><b>˻ Է ʾҽϴ.</b></font></center><br>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);

        $cnt = 0;       
        
        print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
        print "<tr><td>\n";
    
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @value = split(/\|/,$datum[$i]);
            if($FORM{'cp'} eq 'subject') {  
                if($value[9] =~ /$FORM{'word'}/i) {
                    $value[9] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g; # ˻ ܾ  ǥ
                    &printRecord;
                    $cnt++;
                }
            }
            elsif($FORM{'cp'} eq "name") {            	
	       if($value[2] =~ /$FORM{'word'}/i) {
	             $value[2] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                     &printRecord;
                     $cnt++;                     
	       }
            } 
            elsif($FORM{'cp'} eq "content") { 
	        if($value[6] =~ /$FORM{'word'}/i) {
                      &printRecord;
                      $cnt++;                      
                }
            }
            elsif($FORM{'cp'} eq "all") {   # ü ˻  ˻ ܾ  ǥ
                   if($value[9] =~ /$FORM{'word'}/i) {
                      $value[9] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;
                   }
	   elsif($value[2] =~ /$FORM{'word'}/i) {
	      $value[2] =~ s/$FORM{'word'}/\<font\ color=red>$FORM{'word'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;                     
	   }                
	   elsif($value[6] =~ /$FORM{'word'}/i) {
                      &printRecord;
                      $cnt++;                      	       
                   }            
            }
       }
       if($cnt < 1) {
           print "<center><font color=red><b>˻ ڷᰡ ϴ.</b></font></center>\n";         
       }
       print "</td></tr><tr><td align=left>&nbsp;Searched Data : <font color=red>$cnt</font></td></tr>\n";        
       print "</td></tr></table>\n";        
    }
    
    print "<br><br><center><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}>ư</a></center>\n";            
    
    &HTMLFooter;  
}

##########################################################################
# ˻  
##########################################################################
sub printRecord {       
        $actual_number = ($gNoOfData+1)-$i;

         if($actual_number > 0) {
             $date_length = length($date);
             $short_date = substr($value[5],0,20);
          
             print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
             print "<tr onMouseOver=this.style.backgroundColor=\"#f5f5f5\" onMouseOut=this.style.backgroundColor=\"\">\n";
             print "<td align=center valign=middle width=5%>$actual_number</td>\n"; #ȣ

             $blank = "";
             if($value[0] eq '1') {
               $blank = "&nbsp;&nbsp;";
             }
             elsif($value[0] eq '2') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             elsif($value[0] eq '3') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             elsif($value[0] eq '4') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             
             if($value[5] eq $date) {                                         #   
                if(($gFileUpload eq "show") || ($gFileLink eq "show")) {       # ڷ
                  if($value[12] ne "") {       # ڷ
                     $Filetype = &GetFileType($value[12]);                	                	
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; # 
                  }
                  elsif(($value[12] eq "") && ($value[3] ne "")) {     # ڷ
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; # 
                  }
                  else {
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; #                   	
                  }
                }
                else {                   # Խ
                   print "<td align=left valign=middle width=63%\">&nbsp;$blank<img src=\"$gIMG_Board/old.gif\" border=0>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage>$value[9]</a> <img src=\"$gIMG_Board/new.gif\" border=0></td>\n"; #                 	                
                }
             }
             else {                                                                       #   찡 ƴ 
                if(($gFileUpload eq "show") || ($gFileLink eq "show")) {       # ڷ
                  if($value[12] ne "") {       # ڷ
                     $Filetype = &GetFileType($value[12]);                	                	
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&cp=$FORM{'cp'}&word=$FORM{'word'}>$value[9]</a></td>\n"; # 
                  }
                  elsif(($value[12] eq "") && ($value[3] ne "")) {     # ڷ
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&cp=$FORM{'cp'}&word=$FORM{'word'}>$value[9]</a></td>\n"; # 
                  }
                  else {
                     $Filetype = &GetFileType($value[3]);
                     print "<td align=left valign=middle width=56%\">&nbsp;$blank<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&cp=$FORM{'cp'}&word=$FORM{'word'}>$value[9]</a></td>\n"; #                   	
                  }
                }
                else {                   # Խ
                   print "<td align=left valign=middle width=63%\">&nbsp;$blank<img src=\"$gIMG_Board/old.gif\" border=0>&nbsp;<a href=$gCGI_Board?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&cp=$FORM{'cp'}&word=$FORM{'word'}>$value[9]</a></td>\n"; #                 	                
                }
             }
             
             if($value[4] eq "") {
                print "<td align=center valign=middle width=10%>$value[2]</td>\n";   # ̸
             }
             else {
             	if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                   print "<td align=center valign=middle width=10%><a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[2]</a></td>\n";   # ̸                
                }
                else {
                   print "<td align=center valign=middle width=10%><a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\">$value[2]</a></td>\n";   # ̸                
                }                
             }
             
             if(($gFileUpload eq "show") || ($gFileLink eq "show")) {
             	if(($value[10]eq "") && ($value[3]eq "")){          # v1.0 ȣȯ
             	   $value[10] = 0;
             	   $value[10] = 0;
                }
                if($value[10] >= $gMinmumHit) {
                   print "<td align=right valign=middle width=7%><font color=red>$value[10]</font>&nbsp;</td>\n"; # ٿ
                }
                else {
                   print "<td align=right valign=middle width=7%>$value[10]&nbsp;</td>\n"; # ٿ                	
                }
             }

             if($value[11] >= $gMinmumHit) {
                print "<td align=right valign=middle width=7%><font color=red>$value[11]</font>&nbsp;</td>\n"; # ȸ
             }
             else {
                print "<td align=right valign=middle width=7%>$value[11]&nbsp;</td>\n"; # ȸ
             }                          
             
             print "<td align=center valign=middle width=15%>$value[5]</td>\n"; # 
             print "</tr>\n";
             if(($gFileUpload eq "show") || ($gFileLink eq "show")) {
                print "<tr><td colspan=6 width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";
             }
             else {
                print "<tr><td colspan=5 width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";             	
             }
             print "</table>\n";
      }
}

##############  Ÿ ˾Ƴ ###########################################
sub GetFileType {
  my( $ext, $data );
  my( @TempArray ) = split(/\./,$_[0]);

@ExeFile = ( "bat", "com", "exe", "EXE" );
@BmpFile = ( "bmp");
@GifFile = ( "gif");
@JpgFile = ( "jpg, jpeg");
@ZipFile = ( "zip", "rar", "arj", "zoo", "pak", "ace", "tar", "z", "gz" );
@RarFile = ( "rar");
@TxtFile = ( "txt", "cap", "gal", "lst", "TXT", "CAP", "GAL");
@DocFile = ( "doc", "DOC");
@HwpFile = ( "hwp", "HWP");
@HtmFile = ( "html", "htm" );
@SndFile = ( "wav", "aa3", "aac", "mid", "s3m", "voc", "wrk", "mod", "rol", "ims" );
@Mp3File = ( "mp3", "mp2");
@RaFile = ( "ra", "ram" );
@MovFile = ( "mov", "avi", "rm", "mpg" );
@IsFile = ("ist");
@JsFile = ("js");
@ExcelFile = ("xls");
@Ppt = ("ppt");
@FlashFile = ("swf");
@CgiFile = ("cgi", "pl");
@PhpFile = ("php", "php3", "php4");
@Nothing = ("");
  $ext = $TempArray[@TempArray-1] if( @TempArray );
  lc( $ext );

  foreach $data (@ExeFile) { return  "exe.gif" if( $ext eq $data ); }
  foreach $data (@GifFile) { return  "gif.gif" if( $ext eq $data ); }
  foreach $data (@JpgFile) { return  "jpg.gif" if( $ext eq $data ); }
  foreach $data (@BmpFile) { return  "bmp.gif" if( $ext eq $data ); }
  foreach $data (@IsFile) { return  "is.gif" if( $ext eq $data ); }
  foreach $data (@JsFile) { return  "js.gif" if( $ext eq $data ); }
  foreach $data (@ZipFile) { return  "zip.gif" if( $ext eq $data ); }
  foreach $data (@RarFile) { return  "rar.gif" if( $ext eq $data ); }
  foreach $data (@ExcelFile) { return  "xls.gif" if( $ext eq $data ); }
  foreach $data (@TxtFile) { return  "text.gif" if( $ext eq $data ); }
  foreach $data (@HwpFile) { return  "hwp.gif" if( $ext eq $data ); }
  foreach $data (@HtmFile) { return  "html.gif" if( $ext eq $data ); }
  foreach $data (@SndFile) { return  "mid.gif" if( $ext eq $data ); }
  foreach $data (@Mp3File) { return  "mp3.gif" if( $ext eq $data ); }
  foreach $data (@RaFile) { return  "ra.gif" if( $ext eq $data ); }  
  foreach $data (@PptFile) { return  "ppt.gif" if( $ext eq $data ); }    
  foreach $data (@MovFile) { return  "mpeg.gif" if( $ext eq $data ); }
  foreach $data (@FlashFile) { return  "swf.gif" if( $ext eq $data ); }  
  foreach $data (@CgiFile) { return  "cgi.gif" if( $ext eq $data ); }  
  foreach $data (@PhpFile) { return  "php3.gif" if( $ext eq $data ); }      
  foreach $data (@Nothing) { return  "nothing.gif" if( $ext eq $data ); }        
  return  "unknown.gif";
}

##########################################################################
# Ϻ
##########################################################################
sub sendMail {
    open(MAIL,"|$gEmailPgm -t $mail");
    print MAIL "To: $email\n";
    print MAIL "From: $gAdminEmail\n";
    print MAIL "Subject: $gEmailSubject\n";
    $gEmailContent =~ s/<p>/\n\n/g;
    $gEmailContent =~ s/<br>/\n/g;
    print MAIL "$gEmailContent";
    close(MAIL);
}

##########################################################################
# ޼
##########################################################################
sub Alert {
    print "CONTENT-TYPE:TEXT/HTML\n\n";
    print "<script>
	   window.alert('$msg');
	   history.go(-1);
	   </script>";
    exit;
}

##########################################################################
#  α δ
##########################################################################
sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
       
    &HTMLHeader;   
    print "<TABLE WIDTH=220 valign=top align=center border=0 background=$gIMG_Board/m_bg.gif>\n";    
    print "<tr><td align=center valign=top>\n";    
    print "<form method=post name=userlogin action=$gCGI_Board>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    if($FORM{'c'} eq "delete") {    
       print "<center><br><b>Delete</b><br><br><center>\n";
    }
    if($FORM{'c'} eq "show_update_form") {
       print "<center><br><b>Modify</b><br><br><center>\n";    	
    }
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=12 maxlength=16> \n";
    print "</td></tr>\n";
    print "<tr><td align=right valign=top>\n";
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "delete");
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "show_update_form");
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print "</form>\n";
    print "<br><br><br><br></td></tr></table>\n";
    print "<script language=\"javascript\">document.userlogin.passwd.focus();</script>\n";
    
    &HTMLFooter;       
}

##########################################################################
#  ȣ üũѴ
##########################################################################
sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
        print "<br><br><hr noshade width=80%>\n";
        print "<center><font color=$gTextColor> йȣ ġ ʽϴ.</font></center>\n";        
        print "<hr noshade width=80%>\n";
        print "</form><p><center><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
        &HTMLFooter;
    } 
    
}

##########################################################################
# ϵ ȭ Ѵ
##########################################################################
sub deleteData {
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock;
    open(HANDLE,">$gBaseDIR/$gDatFile");    
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
        else {
            $attach_filename = $value[12];
        }
    }
    close(HANDLE);
    &unlock;
    
    if($attach_filename) {
       unlink ("$gUploadDIR/$attach_filename");
    }
        
    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");

    &getNumber;
    $gNoOfData--;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Board $gVerBoard
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";
    print "<html>\n";
    print "<title>Beomdori's Board $gVerBoard</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
# ϵ ȭ  Ʈ 
##########################################################################
sub showUpdateForm {
    local($data,$name,$value);
    local(@cookies);
    
    # Ű б
    local(@value);
    &GET_COOKIE;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             
    
    &HTMLHeader;  
    if($gUserType eq "type_member") {             	    
       print "<form method=post name=updateform action=$gCGI_Board>\n";
       print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
       print "<input type=hidden name=action value=update>\n";
       print "<input type=hidden name=p value=$FORM{'p'}>\n";
       print "<input type=hidden name=l value=$FORM{'l'}>\n";
       print "<input type=hidden name=OldPassword value=$value[0]>\n";
       print "<input type=hidden name=passwd value=$value[0]>\n";
       print "<br><br><table border=0 cellspacing=0 cellpadding=0 align=center>\n";
       print "<tr><td>\n";

       print "<table border=0 cellspacing=1 cellpadding=2>\n";    
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       $value[2] =~ s/<br>/\n/g;
       print "<input type=hidden name=name value=$value[2]><font color=777777 face=\"\">$value[2]</font></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input type=hidden name=email value=$value[4]><font color=777777 face=\"\">$value[4]</font></td></tr>\n";               
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=hidden value=\"$value[8]\"><font color=777777 face=\"\">$value[8]</font></td></tr>\n";  
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       print "<input type=text name=subject value=\"$value[9]\" size=40 maxlength=40 class=text> <input type=checkbox name=html value=enable style=\"background-color:$gBackColor;border:0\">html</td></tr>\n";
       $value[6] =~ s/<br>/\n/g;
       $value[6] =~ s/<p>/\n\n/g;
       print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment>$value[6]</textarea></td>\n";    
       print "</tr>\n";      
       print "<tr><td align=right><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value=\"$value[3]\" class=text size=63>
                <input type=hidden name=fileupload value=\"$value[12]\">
                </td></tr>\n";      # ϸũ, Ͼε       
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.updateform.content.focus();</script>\n";
    }
    else {
       print "<form method=post name=updateform action=$gCGI_Board>\n";
       print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
       print "<input type=hidden name=action value=update>\n";
       print "<input type=hidden name=p value=$FORM{'p'}>\n";
       print "<input type=hidden name=l value=$FORM{'l'}>\n";
       print "<input type=hidden name=OldPassword value=$value[0]>\n";
       print "<input type=hidden name=passwd value=$value[0]>\n";       
       print "<br><br><table border=0 cellspacing=0 cellpadding=0 align=center>\n";
       print "<tr><td>\n";

       print "<table border=0 cellspacing=1 cellpadding=2>\n";    
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       $value[2] =~ s/<br>/\n/g;
       print "<input name=name value=\"$value[2]\" type=text size=20 class=text maxlength=6></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input type=hidden name=filelink value=\"$value[3]\">\n";                             # Ӽ : ϸũ
       print "<input name=email value=\"$value[4]\" type=text size=40 class=text></td></tr>\n";               
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value=\"$value[8]\" size=40 type=text class=text></td></tr>\n";  
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       print "<input type=text name=subject value=\"$value[9]\" size=40 maxlength=40 class=text> <input type=checkbox name=html value=enable style=\"background-color:$gBackColor;border:0\">html</td></tr>\n";
       $value[6] =~ s/<br>/\n/g;
       $value[6] =~ s/<p>/\n\n/g;
       print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment>$value[6]</textarea></td>\n";    
       print "</tr>\n";
       print "<tr><td align=right><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value=\"$value[3]\" class=text size=63>
                <input type=hidden name=fileupload value=\"$value[12]\">
                </td></tr>\n";      # ϸũ, Ͼε       
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.updateform.content.focus();</script>\n";
    }

    &HTMLFooter;       
}

##########################################################################
# йȣ ȣȭѴ
##########################################################################
sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

##########################################################################
#  ȭ Ѵ
##########################################################################
sub makeNewFile { 
    local(@set);

    &getDate;
    
    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    open(HANDLE,">$gBaseDIR/data/$gRandomFilename.cgi");
        print HANDLE "$gCryptPassword|$gRandomFilename|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|0|0|$fname||||\n";
    close(HANDLE);
}

##########################################################################
# ȭϿ  Ѵ
##########################################################################
sub appendIndexFile {
    local($data);
    local(@datum,@point);

    &lock;
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    # 亯 ߰ 
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;        # ù° 0,  ޶ 1 
                  print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|0|0|$fname||||\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	  print HANDLE "0|$gRandomFilename|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|0|0|$fname||||\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}


##########################################################################
# ٿεϱ
##########################################################################
sub downloadData {
       if(-e "$gBaseDIR/data/$FORM{'l'}.cgi") {
         &addHitDownCounter;
         
         if(($FORM{'file'}=~ /http:\/\/.+/) || ($FORM{'file'}=~ /ftp:\/\/.+/)) {
            print "Location:$FORM{'file'}\n\n";
         }
         else {
            print "Location:$gUploadURL/$FORM{'file'}\n\n";
         }	
         exit;
      }	
}


##########################################################################
# ȸ
##########################################################################
sub addHitCounter {
    local($data,$temp);
    local(@datum,@value,@t);

    &lock; 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");   
    for($i=0;$i<=$gNoOfData;$i++) {
        @value = split(/\|/,$datum[$i]);             
        if ($i eq $FORM{'n'}) {                           # $FORM{'n'} ̸ ȸ 
            $filen = "$value[1].cgi";
            $value[11]++;
            print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]|$value[7]|$value[8]|$value[9]|$value[10]|$value[11]|$value[12]|$value[13]|$value[14]|$value[15]|\n";
        }
        else {
            print HANDLE $datum[$i];
        }
    }
    close(HANDLE);
    &unlock;
    
    &GET_COOKIE;
    open(HANDLE,"<$gBaseDIR/data/$filen");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);
        
    $t[11] = $t[11] + 1;
    open(HANDLE,">$gBaseDIR/data/$filen");
            print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]|$t[10]|$t[11]|$t[12]|$t[13]|$t[14]|$t[15]|\n";
    close(HANDLE);    
}

##########################################################################
# ٿ
##########################################################################
sub addHitDownCounter {
    local($data,$temp);
    local(@datum,@value,@t);

    &lock; 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");   
    for($i=0;$i<=$gNoOfData;$i++) {
        @value = split(/\|/,$datum[$i]);             
        if ($i eq $FORM{'d'}) {                           # $FORM{'n'} ̸ ٿ 
            $filen = "$value[1].cgi";
            $value[10]++;
            print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]|$value[7]|$value[8]|$value[9]|$value[10]|$value[11]|$value[12]|$value[13]|$value[14]|$value[15]|\n";
        }
        else {
            print HANDLE $datum[$i];
        }
    }
    close(HANDLE);
    &unlock;
    
    &GET_COOKIE;
    open(HANDLE,"<$gBaseDIR/data/$filen");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);
        
    $t[10] = $t[10] + 1;
    open(HANDLE,">$gBaseDIR/data/$filen");
            print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]|$t[10]|$t[11]|$t[12]|$t[13]|$t[14]|$t[15]|\n";
    close(HANDLE);    
}
 
##########################################################################
# Ʈ  ϵ ȭ ã Ѵ
##########################################################################
sub updateData {
    local(@datum,@value);

    &getVariable;
   
    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                            0     |ȣ      |̸ |ϸũ|̸|¥ |    |ip |Ȩ |    |ٿ|ȸ|Ͼε||||
            print HANDLE "$value[0]|$FORM{'l'}|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|$value[10]|$value[11]|$fname||||\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                         ȣ            |ȭϸ    |̸ |ϸũ|̸|¥ |    |ip |Ȩ |    |ٿ|ȸ|Ͼε||||
        print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|$value[10]|$value[11]|$fname||||\n";
    close(HANDLE);

    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Board $gVerBoard
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";
    print "<html>\n";
    print "<head>\n<title>Beomdori's Board $gVerBoard</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";

    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
#  α
##########################################################################
sub showAdminLogin {
    local($command);
    	
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Board/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	
        print "<br><form action=$gCGI_Board name=passwdconfig>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=50 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<br></td></tr></table>\n";            
        print "<script language=\"javascript\">document.passwdconfig.newpasswd.focus();</script>\n";                        
    }
    else {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Board/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	    	
        print "<br><form method=post name=config action=$gCGI_Board>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<b>Config</b><br>\n";      
        print "<br>йȣ&nbsp;<input type=password name=oldpasswd size=12 maxlength=16>\n";
        print "</td></tr>\n";
        print "<tr><td align=right valign=top>\n";                    
        print " <input type=submit value=\" Ȯ \">\n";
        print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";            
        print "</form>\n";
        print "<br><br><br><br></td></tr></table>\n";                    
        print "<script language=\"javascript\">document.config.oldpasswd.focus();</script>\n";
    }
    &HTMLFooter;
    close(HANDLE);
}

##########################################################################
#  ȣüũ
########################################################################## 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);

    
    # йȣ űԷ
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                print "<br><br><hr noshade width=80%>\n";
                print "<font color=blue> йȣ Է ʾҽϴ</font>\n";
                print "<hr noshade width=80%>\n";
                print "</form><p><center><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";

                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<center><font color=blue> йȣ ġ ʽϴ</font></center>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><center><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
            &HTMLFooter;
        } 
    } 

    # йȣ Ȯ
    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<center><font color=blue> йȣ ġ ʽϴ</font></center>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><center><a href=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
            &HTMLFooter;
        }
    }
}

##########################################################################
# ȣ üũ
##########################################################################
sub checkConfigPassword {
    local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
    local(@set);
 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<br>| <a href=\"javascript:history.back()\">ڷ</a> |\n";
            print "<br><br><hr noshade width=80%>\n";
            print "<center><font color=blue>ȯ漳 Ȯ   йȣ ġ ʽϴ.</font></center>\n";
            print "<hr noshade width=80%>\n";
            &HTMLFooter;
        }
}


##########################################################################
# ڿ  ȯ漳
##########################################################################
sub showConfigForm {
    &HTMLHeader;
    print "<br><b><center><font color=\"3355cc\">Configuration For <b>$gSupervisor_HomeName</b></font></center></b><br><br>\n";
    print "<table border=0 width=500 align=$gAlignType><tr><td>\n";
    print "<form action=$gCGI_Board>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";
    print "<input type=hidden name=DesignType value=board>\n";
    print "<tr><td align=left>User Type</td>\n";
    print "<td align=right><select name=UserType>\n";
    if($gUserType eq "type_normal") {
        print "<option value=type_normal selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        print "<option value=type_member>ȸ&nbsp;&nbsp;";
    }
    elsif($gUserType eq "type_member") {
        print "<option value=type_normal>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        print "<option value=type_member selected>ȸ&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";
    print "</table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td align=left>йȣ</td><td align=right><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
    print "<tr align=right><td align=left>Է</td><td align=right><input type=password name=repasswd size=12 maxlength=16>\n";
    print "</td></tr></table><br>\n";

######
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::  :: </b></td></tr>\n";
    
    print "<tr><td align=left>Title</td>\n";
    print "<td align=right><select name=TitleUse>\n";
    if($gTitleUse eq "YES" || $gTitleUse eq "") {
        print "<option value=YES selected>̱";
        print "<option value=NO>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gTitleUse eq "NO") {
        print "<option value=YES>̱";
        print "<option value=NO selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";    
    
    print "<tr><td align=left>Background Color</td><td align=right><table border=1  bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gBackColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Text Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Background URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=40></td></tr>\n";
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left> </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTitleBgColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableTitleBgColor value=\"$gTableTitleBgColor\" size=10></td></tr>\n";
    print "<tr><td align=left> ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTitleTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableTitleTextColor value=\"$gTableTitleTextColor\" size=10></td></tr>\n";    
    print "<tr><td align=left> </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableBgColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableBgColor value=\"$gTableBgColor\" size=10></td></tr>\n";
    print "<tr><td align=left> ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableTextColor value=\"$gTableTextColor\" size=10></td></tr>\n";    
    print "<tr><td align=left>Ȱȭ ̺ Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gActiveTableColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=10></td></tr>\n";
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left>Ĺ</td><td align=right><select name=AlignType>\n";
    if($gAlignType eq "left") {
        print "<option value=left selected>Left";
        print "<option value=center>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gAlignType eq "center" || $gAlignType eq "") {
        print "<option value=left>Left";
        print "<option value=center selected>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gAlignType eq "right") {
        print "<option value=left>Left";
        print "<option value=center>Center";
        print "<option value=right selected>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";            

    print "<tr><td align=left>Ϻ̱</td><td align=right><select name=FList>\n";
    if($gFList eq "show") {
        print "<option value=show selected>̱";
        print "<option value=hide>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gFList eq "hide" || $gFList eq "") {
        print "<option value=show>̱";
        print "<option value=hide selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";            

    print "<tr><td align=left>Ͼε</td><td align=right><select name=FileUpload>\n";
    if($gFileUpload eq "show") {
        print "<option value=show selected>̱";
        print "<option value=hide>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gFileUpload eq "hide" || $gFileUpload eq "") {
        print "<option value=show>̱";
        print "<option value=hide selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";            

    print "<tr><td align=left>ϸũ</td><td align=right><select name=FileLink>\n";
    if($gFileLink eq "show") {
        print "<option value=show selected>̱";
        print "<option value=hide>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gFileLink eq "hide" || $gFileLink eq "") {
        print "<option value=show>̱";
        print "<option value=hide selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";            

    print "<tr><td align=left>εϿ뷮</td><td align=right><font color=999999>( : KB)</font> <input type=text name=MaxFileSize value=\"$gMaxFileSize\" size=12 maxlength=6></td></tr>\n";                
    print "<tr><td align=left>Table Size</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=12 maxlength=4></td></tr>\n";
    print "<tr><td align=left>ȸ,ٿ </td><td align=right><input type=text name=MinmumHit value=\"$gMinmumHit\" size=12 maxlength=3></td></tr>\n";    
    print "<tr><td align=left>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>Ʈ  </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=12 maxlength=2></td></tr>\n";
    print "</table><br>\n";

    print "<p align=center>\n";
    print "<input type=submit value=\" Ȯ  \">\n";
    print "</form>\n";
    print "</tr></td></table>\n";

    &HTMLFooter;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gUserType = $FORM{'UserType'};
    $gDesignType = $FORM{'DesignType'};    
    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTableTextColor = $FORM{'TableTextColor'};
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
    $gListNumber = $FORM{'ListNumber'};
    $gActiveTableColor = $FORM{'ActiveTableColor'};
    $gTitleUse = $FORM{'TitleUse'};
    $gTableBgColor = $FORM{'TableBgColor'};
    $gAlignType = $FORM{'AlignType'};
    $gFList = $FORM{'FList'};        
    $gFileUpload = $FORM{'FileUpload'};
    $gMaxFileSize = $FORM{'MaxFileSize'};
    $gFileLink = $FORM{'FileLink'};    
    $gTableTitleBgColor = $FORM{'TableTitleBgColor'};
    $gTableTitleTextColor = $FORM{'TableTitleTextColor'};
    $gMinmumHit = $FORM{'MinmumHit'};
            
    $gTempURL2 = $FORM{'TempURL2'} if($FORM{'TempURL2'} =~ /^http:\/\// || $FORM{'TempURL2'} eq "");  
    $gTempColor1 = $FORM{'TempColor1'};
    $gTempColor2 = $FORM{'TempColor2'};
    $gTempColor3 = $FORM{'TempColor3'};    
    $gTempColor4 = $FORM{'TempColor4'};
    $gTempColor7 = $FORM{'TempColor7'};    
    $gTempColor8 = $FORM{'TempColor8'};
    $gTempColor9 = $FORM{'TempColor9'};    
    $gTempColor11 = $FORM{'TempColor11'};
    $gTempColor12 = $FORM{'TempColor12'};    
        
    $gTempYesOrNo1 = $FORM{'TagUse'};    
    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    $gTempYesOrNo3 = $FORM{'TempYesOrNo3'};
    $gTempYesOrNo4 = $FORM{'TempYesOrNo4'};
    $gTempYesOrNo5 = $FORM{'TempYesOrNo5'};
    $gTempYesOrNo6 = $FORM{'TempYesOrNo6'};    
    
    &putEnvVar;
    $gCurPage = $FORM{'p'};   

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=\"0;url=$gCGI_Board?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";
    print "</html>\n";
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}

 # ȣ |ȭϸ    |̸ |ũ|̸|¥ |    |ip |Ȩ |    |ٿ|ȸ|ε ϸ||||
#value0 = ȣ
#value1 = ȭϸ
#value2 = ̸
#value3 = ũ
#value4 = ̸
#value5 = ¥
#value6 = 
#value7 = IP
#value8 = Ȩ
#value9 = 
#value10 = ٿ
#value11 = ȸ
#value12 = ε ϸ
#value13 = 
#value14 = 
#value15 = 
 